/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
*/
//This controller retrieves data from the reportFactory/experimentFactory through the REST API and associates it with the $scope
//The $scope is ultimately bound to the report view
//app.controller('plotterparameterController',['$scope', 'reportFactory', 'experimentFactory', 'plotterFactory', 'dataFactory', '$q', function ($scope, reportFactory, experimentFactory, plotterFactory, dataFactory, $q)
app.controller('plotterparameterController',['$scope', 'plotterFactory', 'plotterparameterFactory', '$q', function ($scope, plotterFactory, plotterparameterFactory, $q)
{
   $scope.q = $q;
   $scope.user;
   $scope.plotterparameter_id;
   $scope.url_prefix;
   $scope.plotterFactory = plotterFactory;
   $scope.plotterparameterFactory = plotterparameterFactory;
   $scope.plotters = {};
   $scope.plotters.selected = undefined;
   $scope.plotterparameterData = {};
   $scope.textdata = [];
   $scope.plotterparams_update = {};
   $scope.plotterparams_newversion = {};
   $scope.plotterparams_fork = {};
   $scope.plotterparameter_forking = undefined;

   $scope.init = function(user, plotterparameter, url_prefix, data_itemcontent_file, data_table_itemcontent_file)
   {
       $scope.user   = user;
       $scope.plotterparameter = plotterparameter;
       $scope.plotterparameter_user = plotterparameter.split("/")[0];
       $scope.plotterparameter_name = plotterparameter.split("/")[1];
       $scope.plotterparameter_version = plotterparameter.split("/")[2];
       $scope.url_prefix = url_prefix;

       if($scope.plotterparameter == 'CREATION_MODE')
       {
           getPlottersData($scope.user);
       }
       else
       {
           getPlotterParameterData($scope.user, $scope.plotterparameter_user, $scope.plotterparameter_name, $scope.plotterparameter_version);
       }
   }

   function getPlottersData(user)
   {
       plotterFactory.getPlottersInformation(user, $scope.url_prefix)
           .success(function (plottersData)
           {
               $scope.plotters = plottersData;
               for(var init_selected_plotter in plottersData)
               {
                   $scope.plotters.selected = init_selected_plotter.name;
               }
           })
           .error(function (error)
           {
               $scope.status = 'Unable to load report data: ' + error.message;
           });

           $('#tabs_progress').hide();
   }

   function getPlotterParameterData(user, plotterparameter_user, plotterparameter_name, plotterparameter_version)
   {
       plotterparameterFactory.getPlotterParameterInformation(user, plotterparameter_user, plotterparameter_name, plotterparameter_version, $scope.url_prefix)
           .success(function (plotterparameterData)
           {
               $scope.plotters = plotterparameterData.plotters;
               for(var init_selected_plotter in plotterparameterData.plotters)
               {
                   $scope.plotters.selected = init_selected_plotter;
               }
               $scope.plotterparameterData = plotterparameterData;

               if(plotterparameterData.plotter != "undefined plotter")
               {
                    //Find selected plotter
                    $.each(plotterparameterData.plotters, function( key, value ) {

                      if(key == plotterparameterData.plotter)
                      {
                            $scope.plotters.selected = value;
                            //break
                            return false;
                      }
                    });

                    $.each($scope.plotters.selected.declaration.parameters, function( key, value ) {
                        //push all keys in array
                        $scope.textdata.push(key);

                        //check if already saved key/values for this plotterparameter and add
                        $.each($scope.plotterparameterData.data, function(keysaved, valuesaved){
                                if(key == keysaved)
                                {
                                    $scope.plotterparams_update[keysaved] = valuesaved;
                                    return false;
                                }

                            });
                    });
                    //$scope.textdata = $scope.plotters.selected.declaration.parameters;

                    addParametersToEditor();
               }
           })
           .error(function (error)
           {
               $scope.status = 'Unable to load report data: ' + error.message;
           });

           $('#tabs_progress').hide();
   }

   function addParametersToEditor()
   {
       $scope.$broadcast("addParametersElement");
   }
}]);
