# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import migrations, models

from datetime import datetime, timedelta
from django.conf import settings

def add_timeout_to_existing_locked_report(apps, schema_editor):
    report_model = apps.get_model("reports", "report")

    for single_report in report_model.objects.all():
        if single_report.status == 'L':
            single_report.expiration_date = datetime.now() + timedelta(days=settings.EXPIRATION_DELTA)
            single_report.save()

def backward_dummy(apps, schema_editor):
    pass

class Migration(migrations.Migration):

    dependencies = [
        ('reports', '0001_initial'),
    ]

    operations = [
        migrations.AddField(
            model_name='report',
            name='expiration_date',
            field=models.DateTimeField(null=True, blank=True),
        ),

        migrations.RunPython(add_timeout_to_existing_locked_report,
                             backward_dummy)
    ]
