/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

/*
 * bootstrapModal
 * Desc:
 *  represents a modal from Bootstrap 3
 */
angular.module('reportApp')
.directive("bootstrapModal", [function(){
    return {
        scope: {
            domId: '@',
            buttonCancelFunc: '&',
            buttonSubmitFunc: '&',
            buttonCancelText: '@',
            buttonSubmitText: '@'
        },
        link: function(scope){
        },
        transclude: {
            'title': '?bTitle',
            'content': '?bContent',
            'footer': '?bFooter'
        },
        template: `
<div class="modal fade" id="{{ domId }}" tabindex="-1" role="dialog" aria-labelledby="reportModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="reportModalLabel" ng-transclude='title'>Modal Title</h4>
            </div>
            <div class="modal-body" ng-transclude='content'>
                Content
            </div>
            <div class="modal-footer" ng-transclude='footer'>
                <button ng-click='buttonCancelFunc && buttonCancelFunc()()' type="button" class="btn btn-default" data-dismiss="modal">
                    Cancel
                </button>
                <button ng-if='buttonSubmitText' ng-click='buttonSubmitFunc && buttonSubmitFunc()()' type="button" class="btn btn-primary" data-dismiss="modal">
                    {{ buttonSubmitText }}
                </button>
            </div>
        </div>
    </div>
</div>
`
    };
}]);
