/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

/*
 * groupsLayout
 * Desc:
 *  controls the layout of the reports content,
 *  generating group panels using the GroupsService data,
 *  and holding the menu for adding a group
 */
angular.module('reportApp').directive("groupsLayout", ['GroupsService', 'UrlService', function(GroupsService, UrlService){
    return {
        scope: {
        },
        link: function(scope, el, attr){
            scope.GroupsService = GroupsService;
            scope.isViewmode = UrlService.isViewmode;

            // drag handle CSS selector
            scope.sortableOptions = {
                handle: '.dragGroup .drag-handle'
            };
        },
        template: `
<experiments-table></experiments-table>
<div ng-if='!isViewmode()' group-add-group-menu class='panel'></div>

<div id='groupsLayout' class='panel-group'>
    <div ng-if='!isViewmode() || GroupsService.groups.length > 1'
        ui-sortable='sortableOptions'
        ng-model='GroupsService.groups'
        id='groupsLayout'
        class='panel-group'>
        <div
            group-panel-content
            style='margin-bottom: 5px;'
            ng-repeat='group in GroupsService.groups'
            group='group'>
        </div>
    </div>
    <div ng-if='isViewmode() && GroupsService.groups.length == 1'>
        <group-panel-items group='GroupsService.groups[0]'></group-panel-items>
    </div>
</div>
`
    };
}]);
