/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

/*
 * panelContainer
 * Desc:
 *  displays a Bootstrap panel with the specified header & body content
 */
angular.module('reportApp')
.directive("panelContainer", [function(){
    return {
        scope: {
            noPanelBody: '=',
            domId: '='
        },
        restrict: 'A',
        transclude: {
            'headerSlot': 'header',
            'contentSlot': 'content'
        },
        link: function(scope, el){
            el.addClass('panel panel-default');
        },
        template: `
<div id="{{domId}}-heading" class="panel-heading" role="tab">
    <h4 class="panel-title">
        <a
            class=''
            role="button"
            data-toggle="collapse"
            data-parent="#{{domId}}-heading"
            href="#collapse-{{domId}}"
            aria-expanded="true"
            aria-controls="collapse-{{domId}}">
        </a>
        <span ng-transclude='headerSlot'>Header Content</span>
    </h4>
</div>
<div id="collapse-{{domId}}"
    class="panel-collapse collapse in"
    role="tabpanel"
    aria-labelledby="{{domId}}-heading">
    <div ng-class='{ "panel-body": !noPanelBody }' ng-transclude='contentSlot'>
        Body Content with hasPanelBody: {{ hasPanelBody }}
    </div>
</div>
`
    };
}]);
