/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

/*
 * groupPanelItems
 * Desc:
 *  displays the panel of report items of the group,
 *  using the item container adaptor
 */
angular.module('reportApp').directive("groupPanelItems", [function(){
    return {
        scope: {
            group: '='
        },
        link: function(scope){
            // CSS selector for drag handles for the ui-sortable functionality
            // TODO: this needs to be changed each time the HTML hierarchy changes.
            // Make it hierarchy-independent
            scope.sortableOptions = {
                handle: '.dragItem .drag-handle'
            };
        },
        template: `
<div ui-sortable='sortableOptions' ng-model='group._reportItems' class='panel-group'>
    <div ng-repeat='item in group.reportItems'>
        <div group-table-item
            style='margin-bottom: 5px;'
            ng-if="item.id.includes('table')"
            group='group'
            item-id='item.id'
            content='item.content'>
        </div>
        <div group-plot-item
            style='margin-bottom: 5px;'
            ng-if="item.id.includes('plot')"
            group='group'
            item-id='item.id'
            content='item.content'>
        </div>
        <div group-text-item
            style='margin-bottom: 5px;'
            ng-if="item.id.includes('text')"
            group='group'
            report-item='item'
            item-id='item.id'>
        </div>
    </div>
</div>
`
    };
}]);
