/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
*/
/* beat.ui.reportdialog.js

   Implementation of the 'reports' dialog
*/


// Declaration of our namespaces
if (beat === undefined)
    var beat = {}

if (beat.ui === undefined)
    beat.ui = {}

if (beat.ui.plotterparameter === undefined)
    beat.ui.plotterparameter = {}


beat.ui.plotterparameter.plotterparameter_saved = function(dialog_id, scope)
{
    var num_click = 0;
    // Create the dialog
    $('#' + dialog_id).dialog({
        autoOpen: false,
        resizable: false,
        width: Math.min($(window).width() * 0.6, 700),
        position: { my: "center", at: "center", of: window },
        modal: true,
        closeOnEscape: true,
        buttons: [
            {
                id: 'button-' + dialog_id + '-ok',
                text: 'Ok',
                click: function() {
                    var data = {};
                    $.ajaxSetup({
                        beforeSend: function(xhr, settings) {
                            xhr.setRequestHeader('X-CSRFToken', $.cookie('csrftoken'));
                        }
                    });

                    //$('#' + dialog_id).dialog("close");
                    if(num_click == 0)
                    {
                        num_click++;
                        $(".explanation_text").hide();
                        $('#' + dialog_id).dialog("close");
                        $(".explanation_text").show();
                        num_click = 0;
                        location.reload();
                    }
                }
            },
        ]
    });

    // Display the dialog
    $('#' + dialog_id).dialog("open");
}

beat.ui.plotterparameter.plotterparameter_created = function(dialog_id, scope)
{
    var num_click = 0;
    // Create the dialog
    $('#' + dialog_id).dialog({
        autoOpen: false,
        resizable: false,
        width: Math.min($(window).width() * 0.6, 700),
        position: { my: "center", at: "center", of: window },
        modal: true,
        closeOnEscape: true,
        buttons: [
            {
                id: 'button-' + dialog_id + '-ok',
                text: 'Ok',
                click: function() {
                    var data = {};
                    $.ajaxSetup({
                        beforeSend: function(xhr, settings) {
                            xhr.setRequestHeader('X-CSRFToken', $.cookie('csrftoken'));
                        }
                    });

                    //$('#' + dialog_id).dialog("close");
                    if(num_click == 0)
                    {
                        num_click++;
                        $(".explanation_text").hide();
                        $('#' + dialog_id).dialog("close");
                        $(".explanation_text").show();
                        num_click = 0;
                        if(scope.plotterparameter_forking == undefined)
                        {
                            if(scope.plotterparameter_version == undefined)
                            {
                                window.location = scope.url_prefix + "/" + "plotters/plotterparameter/" + scope.user + "/"+ scope.plotterparams_update.name + "/1";
                            }
                            else
                            {
                                window.location = scope.url_prefix + "/" + "plotters/plotterparameter/" + scope.plotterparameter_user + "/"+ scope.plotterparameter_name + "/" + scope.plotterparams_newversion.version;
                            }
                        }
                        else
                        {
                            scope.plotterparameter_forking = undefined;
                            window.location = scope.url_prefix + "/" + "plotters/plotterparameter/" + scope.user + "/"+ scope.plotterparams_update.name + "/1";
                        }
                    }
                }
            },
        ]
    });

    // Display the dialog
    $('#' + dialog_id).dialog("open");
}
