/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
*/
/* beat.ui.reportdialog.js

   Implementation of the 'reports' dialog
*/


// Declaration of our namespaces
if (beat === undefined)
    var beat = {}

if (beat.ui === undefined)
    beat.ui = {}

if (beat.ui.report === undefined)
    beat.ui.report = {}



beat.ui.report.add_experiments = function(dialog_id, received_data, experiments_list)
{
    // Create the dialog
    $('#' + dialog_id).dialog({
        autoOpen: false,
        resizable: false,
        width: Math.min($(window).width() * 0.6, 700),
        position: { my: "center", at: "center", of: window },
        modal: true,
        closeOnEscape: true,
        buttons: [
            {
                id: 'button-' + dialog_id + '-delete',
                text: 'Ok',
                click: function() {
                    var data = {};
                    $.ajaxSetup({
                        beforeSend: function(xhr, settings) {
                            xhr.setRequestHeader('X-CSRFToken', $.cookie('csrftoken'));
                        }
                    });
                    $("#report_add_experiments .warnings .experimentslist").empty();
                    $("#report_add_experiments .errors .errorslist").empty();
                    $('#' + dialog_id).dialog("close");
                }
            },
        ]
    });

    if (received_data)
    {
        if(experiments_list != undefined)
        {
            $("#report_add_experiments .errors").show();
            var items = [];
            var errors_length = 0;
            $.each( received_data, function( key, value ) {
                if(experiments_list.length != value.length)
                {
                    $("#report_add_experiments .warnings").show();
                    $("#report_add_experiments .warnings .experimentslist").append(experiments_list.length-value.length + "/" + experiments_list.length + " experiments to the report");
                }
                else
                {
                    $("#report_add_experiments .warnings").hide();
                }

                if(value.length  > 1)
                {
                    var allValues = '<ul>';
                    $.each( value, function( key2, value2 ) {
                       allValues += '<li>' + value2 + '</li>';
                    })
                    allValues += '</ul>';
                    items.push('<li>' + key + ": " + allValues + '</li>');
                }
                else
                {
                    items.push('<li>' + key + ": " + value + '</li>');
                }
            })
            $("#report_add_experiments .errors .errorslist").append( items.join('') );
        }
        else
        {
            var items = [];
            items.push('<li>' + received_data.responseText + '</li>');
            $("#report_add_experiments .warnings").hide();
            $("#report_add_experiments .errors .errorslist").append( items.join('') );
        }

    }
    else
    {
        $("#report_add_experiments .warnings").show();
        $("#report_add_experiments .warnings .experimentslist").append(experiments_list.length+ "/" + experiments_list.length + " experiments to the report");
        $("#report_add_experiments .errors").hide();

    }

    // Display the dialog
    $('#' + dialog_id).dialog("open");
}
